<?php
namespace Ems\portalGestor\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\{ Message, Error };
use Zeedhi\Framework\DataSource\DataSet;

use Ems\portalGestor\Service\VinculoService;

class VinculoController {
    /** @var VinculoService */
    protected $vinculoService;

    public function __construct(
        VinculoService $vinculoService
    ) {
      $this->vinculoService = $vinculoService;
    }

    public function getVinculoTodos(
        Request\Filter $request,
        Response $response
    ) {
        try {
            $row = $request->getParameters();

            $vinculos = $this->vinculoService->getVinculoTodos(
                $row
            );

            $response->addDataSet(new DataSet('data', $vinculos));

        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function getVinculoTodosResp(
        Request\Filter $request,
        Response $response
    ) {
        try {
            $row = $request->getParameters();

            $vinculos = $this->vinculoService->getVinculoTodosResp(
                $row
            );

            $response->addDataSet(new DataSet('data', $vinculos));

        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function getHorarioBaseDia(
        Request\Filter $request,
        Response $response    
    ) {
        try {
            $row = $request->getParameters();

            $horarioBase = $this->vinculoService->getHorarioBaseDia(
                $row
            );

            $response->addDataSet(new DataSet('data', $horarioBase));
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }
}